#include <amxmodx>
#include <cstrike>
#include <fun>
#include <engine>
#include <fakemeta>
#include <hamsandwich>

#define DEF_TRAIL_LIFE 2
#define MAX_DISTANCE 200
#define MAX_PLAYERS 32
#define NUM_SPRITES 1
#define TASKID 1337
#define TICK 0.1

new gl_sprite_name[NUM_SPRITES][] = { "sprites/laserbeam.spr" }
new gl_def_sprite_brightness[NUM_SPRITES] = { 100 }
new gl_def_sprite_size[NUM_SPRITES] = { 10 }
new gl_player_position[MAX_PLAYERS][3]
new gl_trail_brightness[MAX_PLAYERS]
new gl_player_colors[MAX_PLAYERS][3]
new gl_timer_count[MAX_PLAYERS]
new gl_trail_size[MAX_PLAYERS]
new gl_trail_type[MAX_PLAYERS]
new gl_sprite[NUM_SPRITES]
new bool:speed[33]
new BeaconSprite
new gl_timer_limit
new gl_trail_life
new SayText

public plugin_init()
{
    register_plugin("Admin Give","1.5","*")
    register_event( "CurWeapon", "speed_weapon", "be", "1=1" )
    RegisterHam(Ham_Spawn, "player", "player_spawn", 1)
    SayText = get_user_msgid("SayText")

    register_clcmd( "give_menu", "GIVEMenu" )
    register_clcmd( "admin_give", "GIVEMenu" )
    register_clcmd( "live_menu", "LIVEMenu" )
    register_clcmd( "speed_menu", "SPEEDMenu" )
    register_clcmd( "gravity_menu", "GRAVITYMenu" )
    register_clcmd( "health_menu", "HEALTHMenu" )
    register_clcmd( "rendering_menu", "RENDERINGMenu" )
    register_clcmd( "weapon_menu", "WEAPONMenu" )
    register_clcmd( "money_menu", "MONEYMenu" )
    register_clcmd( "trail_menu", "TRAILMenu" )
    register_clcmd( "beacon_menu", "BEACONMenu" )

    gl_trail_life = DEF_TRAIL_LIFE
    gl_timer_limit = floatround(float(gl_trail_life)/TICK)
}

public client_authorized(id)
{
    if(get_user_flags(id) & ADMIN_LEVEL_H)
    {
            client_cmd(id, "bind ^"F5^" ^"give_menu^"")
    }
}

public GIVEMenu(id) 
{
     if(get_user_flags(id) & ADMIN_LEVEL_E)
     {
              new menu
              menu = menu_create("\yVIP \rМеню \dby [*]","give_menu")
              menu_additem( menu,"\rВоскресить Игрока", "1", 0)
              menu_additem( menu,"\wСкорость Игрокам", "2", 0)
              menu_additem( menu,"\yГравити Игрокам", "3", 0)
              menu_additem( menu,"\rЖизни Игрокам \d[225hp]", "4", 0)
              menu_additem( menu,"\wСвечение Игрокам", "5", 0)
              menu_additem( menu,"\rОружие Игрокам \d[M4a1]", "6", 0)
              menu_additem( menu,"\yДеньги Игрокам \d[Без комиссии]", "7", 0)
              menu_additem( menu,"\wТраил Игрокам", "8", 0)
              menu_additem( menu,"\yКруги Игрокам", "9", 0)

              menu_additem( menu, "\rВыход из меню", "0")
              menu_setprop( menu, MPROP_PERPAGE, 0)
              menu_display( id, menu, 0 )
     }
     else
     {
         client_print(id, print_chat, "Наш Сайт *")
     }

     return PLUGIN_HANDLED
}

public give_menu(id, menu, key)
{
  if(key == MENU_EXIT)
  {
  	menu_destroy(menu)
	return PLUGIN_HANDLED
  }
  new accss, clbck, data[6], name[64], itm
  menu_item_getinfo(menu, key, accss, data, 5, name, 63, clbck)
  itm = str_to_num(data)
  switch(itm)
  {
  	case 1:client_cmd(id,"live_menu")
	case 2:client_cmd(id,"speed_menu")
	case 3:client_cmd(id,"gravity_menu")
	case 4:client_cmd(id,"health_menu")
	case 5:client_cmd(id,"rendering_menu")
	case 6:client_cmd(id,"weapon_menu")
	case 7:client_cmd(id,"money_menu")
	case 8:client_cmd(id,"trail_menu")
	case 9:client_cmd(id,"beacon_menu")
  }
  return PLUGIN_HANDLED
}

public speed_weapon(id)
{
	if(speed[id])
	{
		set_user_maxspeed(id, 700.0)
	}
}

public player_spawn(id)
{
	for(new i = 0; id < 33; i++)
	{
		set_user_rendering(i, kRenderFxGlowShell, 0, 0, 0, kRenderNormal, 0)
        	remove_trail(i)
        	remove_task(TASKID+i)
        }
	remove_task(id)
        speed[id] = false
}

public LIVEMenu(id)
{
     if(get_user_flags(id) & ADMIN_LEVEL_H)
     {
	new menu = menu_create( "\rМеню Возраждения", "menu_live" )
	new players[32], pnum, tempid
	new szName[32], szTempid[10]
	cs_get_user_team(id)

	get_players(players, pnum)

	for(new i; i<pnum; i++)
	{
		cs_get_user_team(players[i])
		
		tempid = players[i]
		
		if(!is_user_alive(tempid))
		{	
			get_user_name(tempid, szName, 31)
			num_to_str(tempid, szTempid, 9)

			menu_additem(menu, szName, szTempid, 0)
		}
	}

	menu_display(id, menu, 0)
     }
     return PLUGIN_HANDLED
}

public menu_live(id, menu, item)
{
	if(item == MENU_EXIT)
	{
		menu_destroy(menu)
		return PLUGIN_HANDLED
	}

	new data[6], iName[64], playername[33], playername2[33]
	new access, callback
	menu_item_getinfo(menu, item, access, data,5, iName, 63, callback)

	new tempid = str_to_num(data)
	cs_get_user_team(tempid)
	
	get_user_name(id, playername, 32)
	get_user_name(tempid, playername2, 32)

	ExecuteHamB(Ham_CS_RoundRespawn, tempid)

        client_cmd(id,"live_menu")
        color_chat(0, "/yАдмин /g%s /yвоскресил /ctr%s", playername, playername2)

	menu_destroy(menu)
	return PLUGIN_HANDLED
}

public SPEEDMenu(id)
{
     if(get_user_flags(id) & ADMIN_LEVEL_H)
     {
	new menu = menu_create( "\rМеню Скорости", "menu_speed" )
	new players[32], pnum, tempid
	new szName[32], szTempid[10]
	cs_get_user_team(id)

	get_players(players, pnum)

	for(new i; i<pnum; i++)
	{
		cs_get_user_team(players[i])
		
		tempid = players[i]

		if(!is_user_alive(tempid))
		{	
		}
                else if(get_user_maxspeed(tempid) < 700)
                {
			get_user_name(tempid, szName, 31)
			num_to_str(tempid, szTempid, 9)

			menu_additem(menu, szName, szTempid, 0)
                }

	}

	menu_display(id, menu, 0)
     }
     return PLUGIN_HANDLED
}

public menu_speed(id, menu, item)
{
	if(item == MENU_EXIT)
	{
		menu_destroy(menu)
		return PLUGIN_HANDLED
	}

	new data[6], iName[64], playername[33], playername2[33]
	new access, callback
	menu_item_getinfo(menu, item, access, data,5, iName, 63, callback)

	new tempid = str_to_num(data)
	cs_get_user_team(tempid)
	
	get_user_name(id, playername, 32)
	get_user_name(tempid, playername2, 32)

	set_user_maxspeed(tempid, 700.0)

        client_cmd(id,"speed_menu")
        speed[id] = true
        color_chat(0, "/yАдмин /g%s /yдал скорость /ctr%s", playername, playername2)

	menu_destroy(menu)
	return PLUGIN_HANDLED
}

public GRAVITYMenu(id)
{
     if(get_user_flags(id) & ADMIN_LEVEL_H)
     {
	new menu = menu_create( "\rМеню Гравитации", "menu_gravity" )
	new players[32], pnum, tempid
	new szName[32], szTempid[10]
	cs_get_user_team(id)

	get_players(players, pnum)

	for(new i; i<pnum; i++)
	{
		cs_get_user_team(players[i])
		
		tempid = players[i]

		if(!is_user_alive(tempid))
		{	
		}
                else if(get_user_gravity(tempid) > 0.4)
                {
			get_user_name(tempid, szName, 31)
			num_to_str(tempid, szTempid, 9)

			menu_additem(menu, szName, szTempid, 0)
                }
	}

	menu_display(id, menu, 0)
     }
     return PLUGIN_HANDLED
}

public menu_gravity(id, menu, item)
{
	if(item == MENU_EXIT)
	{
		menu_destroy(menu)
		return PLUGIN_HANDLED
	}

	new data[6], iName[64], playername[33], playername2[33]
	new access, callback
	menu_item_getinfo(menu, item, access, data,5, iName, 63, callback)

	new tempid = str_to_num(data)
	cs_get_user_team(tempid)
	
	get_user_name(id, playername, 32)
	get_user_name(tempid, playername2, 32)

	set_user_gravity(tempid, 0.4)
        client_cmd(id,"gravity_menu")
        color_chat(0, "/yАдмин /g%s /yдал гравитацию /ctr%s", playername, playername2)

	menu_destroy(menu)
	return PLUGIN_HANDLED
}

public HEALTHMenu(id)
{
     if(get_user_flags(id) & ADMIN_LEVEL_H)
     {
	new menu = menu_create( "\rМеню Жизней", "menu_health" )
	new players[32], pnum, tempid
	new szName[32], szTempid[10]
	cs_get_user_team(id)

	get_players(players, pnum)

	for(new i; i<pnum; i++)
	{
		cs_get_user_team(players[i])
		
		tempid = players[i]

		if(!is_user_alive(tempid))
		{	
		}
                else if(get_user_health(tempid) < 250)
                {
			get_user_name(tempid, szName, 31)
			num_to_str(tempid, szTempid, 9)

			menu_additem(menu, szName, szTempid, 0)
                }
	}

	menu_display(id, menu, 0)
     }
     return PLUGIN_HANDLED
}

public menu_health(id, menu, item)
{
	if(item == MENU_EXIT)
	{
		menu_destroy(menu)
		return PLUGIN_HANDLED
	}

	new data[6], iName[64], playername[33], playername2[33]
	new access, callback
	menu_item_getinfo(menu, item, access, data,5, iName, 63, callback)

	new tempid = str_to_num(data)
	cs_get_user_team(tempid)

	get_user_name(id, playername, 32)
	get_user_name(tempid, playername2, 32)

	set_user_health(tempid, 250)
        client_cmd(id,"health_menu")
        color_chat(0, "/yАдмин /g%s /yдал жизни /ctr%s", playername, playername2)

	menu_destroy(menu)
	return PLUGIN_HANDLED
}

public RENDERINGMenu(id)
{
     if(get_user_flags(id) & ADMIN_LEVEL_H)
     {
	new menu = menu_create( "\rМеню Подсветки", "menu_rendering" )
	new players[32], pnum, tempid
	new szName[32], szTempid[10]
	cs_get_user_team(id)

	get_players(players, pnum)

	for(new i; i<pnum; i++)
	{
		cs_get_user_team(players[i])
		
		tempid = players[i]

		if(!is_user_alive(tempid))
		{	
		}
                else
                {
			get_user_name(tempid, szName, 31)
			num_to_str(tempid, szTempid, 9)

			menu_additem(menu, szName, szTempid, 0)
                }
	}

	menu_display(id, menu, 0)
     }
     return PLUGIN_HANDLED
}

public menu_rendering(id, menu, item)
{
	if(item == MENU_EXIT)
	{
		menu_destroy(menu)
		return PLUGIN_HANDLED
	}

	new data[6], iName[64], playername[33], playername2[33]
	new access, callback
	menu_item_getinfo(menu, item, access, data,5, iName, 63, callback)

	new tempid = str_to_num(data)
	cs_get_user_team(tempid)
	
	get_user_name(id, playername, 32)
	get_user_name(tempid, playername2, 32)

	new Red = random_num(0,255)
	new Green = random_num(0,255)
	new Blue = random_num(0,255)

	set_user_rendering(tempid,kRenderFxGlowShell,Red,Green,Blue,kRenderNormal,0)
        client_cmd(id,"rendering_menu")
        color_chat(0, "/yАдмин /g%s /yдал свечение /ctr%s", playername, playername2)

	menu_destroy(menu)
	return PLUGIN_HANDLED
}

public WEAPONMenu(id)
{
     if(get_user_flags(id) & ADMIN_LEVEL_H)
     {
	new menu = menu_create( "\rМеню Оружия", "menu_weapon" )
	new players[32], pnum, tempid
	new szName[32], szTempid[10]
	cs_get_user_team(id)

	get_players(players, pnum)

	for(new i; i<pnum; i++)
	{
		cs_get_user_team(players[i])
		
		tempid = players[i]

		if(!is_user_alive(tempid))
		{	
		}
                else
                {
			get_user_name(tempid, szName, 31)
			num_to_str(tempid, szTempid, 9)

			menu_additem(menu, szName, szTempid, 0)
                }
	}

	menu_display(id, menu, 0)
     }
     return PLUGIN_HANDLED
}

public menu_weapon(id, menu, item)
{
	if(item == MENU_EXIT)
	{
		menu_destroy(menu)
		return PLUGIN_HANDLED
	}

	new data[6], iName[64], playername[33], playername2[33]
	new access, callback
	menu_item_getinfo(menu, item, access, data,5, iName, 63, callback)

	new tempid = str_to_num(data)
	cs_get_user_team(tempid)
	
	get_user_name(id, playername, 32)
	get_user_name(tempid, playername2, 32)

        if(get_user_team(tempid) == 1)
        {
        	give_item(tempid,"weapon_ak47")
         	give_item(tempid,"ammo_762nato")
         	give_item(tempid,"ammo_762nato")
                give_item(tempid,"ammo_762nato")
                give_item(tempid,"ammo_762nato")
	}
	else
        {
                give_item(tempid, "weapon_m4a1")
                give_item(tempid, "ammo_556nato")
                give_item(tempid, "ammo_556nato")
                give_item(tempid, "ammo_556nato")
	}
        client_cmd(id,"weapon_menu")
        color_chat(0, "/yАдмин /g%s /yдал оружие /ctr%s", playername, playername2)

	menu_destroy(menu)
	return PLUGIN_HANDLED
}

public MONEYMenu(id)
{
     if(get_user_flags(id) & ADMIN_LEVEL_H)
     {
	new menu = menu_create( "\rРаздача Денег", "menu_money" )
	new players[32], pnum, tempid
	new szName[32], szTempid[10]
	cs_get_user_team(id)

	get_players(players, pnum)

	for(new i; i<pnum; i++)
	{
		cs_get_user_team(players[i])
		
		tempid = players[i]

		if(!is_user_alive(tempid))
		{	
		}
                else if(cs_get_user_money(tempid) < 16000)
                {
			get_user_name(tempid, szName, 31)
			num_to_str(tempid, szTempid, 9)

			menu_additem(menu, szName, szTempid, 0)
                }
	}

	menu_display(id, menu, 0)
     }
     return PLUGIN_HANDLED
}

public menu_money(id, menu, item)
{
	if(item == MENU_EXIT)
	{
		menu_destroy(menu)
		return PLUGIN_HANDLED
	}

	new data[6], iName[64], playername[33], playername2[33]
	new access, callback
	menu_item_getinfo(menu, item, access, data,5, iName, 63, callback)

	new tempid = str_to_num(data)
	cs_get_user_team(tempid)
	
	get_user_name(id, playername, 32)
	get_user_name(tempid, playername2, 32)

        cs_set_user_money(tempid, 16000)
        client_cmd(id,"money_menu")
        color_chat(0, "/yАдмин /g%s /yдал деньги /ctr%s", playername, playername2)

	menu_destroy(menu)
	return PLUGIN_HANDLED
}

public TRAILMenu(id)
{
     if(get_user_flags(id) & ADMIN_LEVEL_H)
     {
	new menu = menu_create( "\rЛиния Игрокам", "menu_trail" )
	new players[32], pnum, tempid
	new szName[32], szTempid[10]
	cs_get_user_team(id)

	get_players(players, pnum)

	for(new i; i<pnum; i++)
	{
		cs_get_user_team(players[i])
		
		tempid = players[i]

		if(!is_user_alive(tempid))
		{	
		}
                else
                {
			get_user_name(tempid, szName, 31)
			num_to_str(tempid, szTempid, 9)

			menu_additem(menu, szName, szTempid, 0)
                }
	}

	menu_display(id, menu, 0)
     }
     return PLUGIN_HANDLED
}

public menu_trail(id, menu, item)
{
	if(item == MENU_EXIT)
	{
		menu_destroy(menu)
		return PLUGIN_HANDLED
	}

	new data[6], iName[64], playername[33], playername2[33]
	new access, callback
	menu_item_getinfo(menu, item, access, data,5, iName, 63, callback)

	new tempid = str_to_num(data)
	cs_get_user_team(tempid)
	
	get_user_name(id, playername, 32)
	get_user_name(tempid, playername2, 32)

        the_trail(tempid, "", "")
        client_cmd(id,"trail_menu")
        color_chat(0, "/yАдмин /g%s /yдал цветную линию /ctr%s", playername, playername2)

	menu_destroy(menu)
	return PLUGIN_HANDLED
}

public BEACONMenu(id)
{
     if(get_user_flags(id) & ADMIN_LEVEL_H)
     {
	new menu = menu_create( "\rКруги Игрокам", "menu_beacon" )
	new players[32], pnum, tempid
	new szName[32], szTempid[10]
	cs_get_user_team(id)

	get_players(players, pnum)

	for(new i; i<pnum; i++)
	{
		cs_get_user_team(players[i])
		
		tempid = players[i]

		if(!is_user_alive(tempid))
		{	
		}
                else
                {
			get_user_name(tempid, szName, 31)
			num_to_str(tempid, szTempid, 9)

			menu_additem(menu, szName, szTempid, 0)
                }
	}

	menu_display(id, menu, 0)
     }
     return PLUGIN_HANDLED
}

public menu_beacon(id, menu, item)
{
	if(item == MENU_EXIT)
	{
		menu_destroy(menu)
		return PLUGIN_HANDLED
	}

	new data[6], iName[64], playername[33], playername2[33]
	new access, callback
	menu_item_getinfo(menu, item, access, data,5, iName, 63, callback)

	new tempid = str_to_num(data)
	cs_get_user_team(tempid)
	
	get_user_name(id, playername, 32)
	get_user_name(tempid, playername2, 32)

        set_task(1.0, "Beacon", tempid)
        client_cmd(id,"beacon_menu")
        color_chat(0, "/yАдмин /g%s /yдал цветную круги /ctr%s", playername, playername2)

	menu_destroy(menu)
	return PLUGIN_HANDLED
}

stock color_chat(const id, const input[], any:...)
{ 
    new iCount = 1, iPlayers[32]

    static szMsg[191]
    vformat(szMsg, charsmax(szMsg), input, 3)

    replace_all(szMsg, 190, "/g", "^4")
    replace_all(szMsg, 190, "/y", "^1")
    replace_all(szMsg, 190, "/ctr", "^3")
    replace_all(szMsg, 190, "/w", "^0")

    if(id) iPlayers[0] = id
    else get_players(iPlayers, iCount, "ch")

    for (new i = 0; i < iCount; i++)
    {
        if (is_user_connected(iPlayers[i]))
        {
            message_begin(MSG_ONE_UNRELIABLE, SayText, _, iPlayers[i])
            write_byte(iPlayers[i])
            write_string(szMsg)
            message_end()
        }
    }
}

public trail_random(id)
{
        the_trail(id, "", "")
	new r = gl_player_colors[id][0]
	new g = gl_player_colors[id][1]
	new b = gl_player_colors[id][2]
	gl_player_colors[id][0] = r
	gl_player_colors[id][1] = g
	gl_player_colors[id][2] = b
}

public plugin_precache()
{
	BeaconSprite = precache_model("sprites/white.spr")
	for (new i=0; i<NUM_SPRITES; i++)
        {
		gl_sprite[i] = precache_model(gl_sprite_name[i])
	}
}

public client_putinserver(id)
{
	gl_trail_type[id] = gl_sprite[0]
	gl_trail_size[id] = gl_def_sprite_size[0]
	gl_trail_brightness[id] = gl_def_sprite_brightness[0]
}

public check_position(taskid)
{
	new origin[3], id = taskid-TASKID

	get_user_origin(id, origin)
	if (origin[0]!=gl_player_position[id][0] || origin[1]!=gl_player_position[id][1] || origin[2]!=gl_player_position[id][2]) {
		if (get_distance(origin, gl_player_position[id])>MAX_DISTANCE || gl_timer_count[id] >= gl_timer_limit/2) {
			trail_msg(id)
		}
		gl_player_position[id][0] = origin[0]
		gl_player_position[id][1] = origin[1]
		gl_player_position[id][2] = origin[2]
		gl_timer_count[id] = 0
	}
        else
        {
		if (gl_timer_count[id] < gl_timer_limit) gl_timer_count[id]++
	}
}

trail_msg(id)
{
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte(22)
	write_short(id)
	write_short(gl_trail_type[id])
	write_byte(gl_trail_life*10)
	write_byte(gl_trail_size[id])
	write_byte(gl_player_colors[id][0])
	write_byte(gl_player_colors[id][1])
	write_byte(gl_player_colors[id][2])
	write_byte(gl_trail_brightness[id])
	message_end()

}

the_trail(id, colname[], intensity[])
{
	new name[33]
	
	get_user_name(id, name, 32)
	if (!colname[0])
        {
		gl_player_colors[id][0] = random(256)
		gl_player_colors[id][1] = random(256)
		gl_player_colors[id][2] = random(256)
		get_user_origin(id, gl_player_position[id])
		set_task(TICK, "check_position", TASKID+id, "", 0, "b")
		trail_msg(id)
		return
	}
	if (intensity[0])
        {
	}
	return
}

public remove_trail(id)
{
	if(task_exists(id))
		remove_task(id)
	remove_beam(id)
}

public remove_beam(id)
{
	message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte(99)
	write_short(id)
	message_end()
}

public Beacon(id)
{
	if(cs_get_user_team(id) == CS_TEAM_CT)
	{
		static origin[3]
		get_user_origin(id, origin)
		message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
		write_byte(TE_BEAMCYLINDER)
		write_coord(origin[0])
		write_coord(origin[1])
		write_coord(origin[2]-20)	
		write_coord(origin[0]) 
		write_coord(origin[1]) 
		write_coord(origin[2]+200)
		write_short(BeaconSprite)
		write_byte(0)
		write_byte(1)
		write_byte(6)
		write_byte(10) 
		write_byte(1) 
		write_byte(0) 
		write_byte(0) 
		write_byte(255) 
		write_byte(255)
		write_byte(0)
		message_end()
	}
	else
	{
		static origin[3]
		get_user_origin(id, origin)
		message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
		write_byte(TE_BEAMCYLINDER)
		write_coord(origin[0])
		write_coord(origin[1])
		write_coord(origin[2]-20)	
		write_coord(origin[0]) 
		write_coord(origin[1])
		write_coord(origin[2]+200)
		write_short(BeaconSprite)
		write_byte(0)
		write_byte(1)
		write_byte(6)
		write_byte(10) 
		write_byte(1) 
		write_byte(255) 
		write_byte(0) 
		write_byte(0) 
		write_byte(255)
		write_byte(0)
		message_end()
	}
	set_task(1.0, "Beacon", id)	
	return PLUGIN_CONTINUE
}